<?php 
 
function pan_notify_get_new_posts()
{
	global $forum_db, $forum_user;

	$query = array(
		'SELECT'	=> 't.forum_id, t.id, t.last_post',
		'FROM'		=> 'topics AS t',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'f.id=t.forum_id'
			),
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
			)
		),
		'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND t.last_post>'.$forum_user['last_visit'].' AND t.moved_to IS NULL'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	$new_topics = array();
	while ($cur_topic = $forum_db->fetch_assoc($result))
		$new_topics[$cur_topic['forum_id']][$cur_topic['id']] = $cur_topic['last_post'];

	//This validete for fetch new posts in field pan_tracked_topics.
	//WARNING! Error in function get_tracked_topics(), global array $ext_info['url'] replacing on /pan_notify/
	if ($forum_db->field_exists('users', 'pan_tracked_topics'))
	{
		if ($forum_user['pan_tracked_topics'])
			$tracked_topics = unserialize($forum_user['pan_tracked_topics']);
		else
			$tracked_topics =  array('topics' => array(), 'forums' => array());
	}
	else
	{
		$tracked_topics = get_tracked_topics();
	}
	
	$query = array(
		'SELECT'	=> 'c.id AS cid, c.cat_name, f.id AS fid, f.forum_name, f.forum_desc, f.redirect_url, f.moderators, f.num_topics, f.num_posts, f.last_post, f.last_post_id, f.last_poster',
		'FROM'		=> 'categories AS c',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'c.id=f.cat_id'
			),
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
			)
		),
		'WHERE'		=> 'fp.read_forum IS NULL OR fp.read_forum=1',
		'ORDER BY'	=> 'c.disp_position, c.id, f.disp_position'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$new_posts_count = 0;
	while ($cur_forum = $forum_db->fetch_assoc($result))
	{
		// Are there new posts since our last visit?
		if (!$forum_user['is_guest'] && $cur_forum['last_post'] > $forum_user['last_visit'] && (empty($tracked_topics['forums'][$cur_forum['fid']]) || $cur_forum['last_post'] > $tracked_topics['forums'][$cur_forum['fid']]))
		{
			// There are new posts in this forum, but have we read all of them already?
			foreach ($new_topics[$cur_forum['fid']] as $check_topic_id => $check_last_post)
			{
				if ((empty($tracked_topics['topics'][$check_topic_id]) || $tracked_topics['topics'][$check_topic_id] < $check_last_post) && (empty($tracked_topics['forums'][$cur_forum['fid']]) || $tracked_topics['forums'][$cur_forum['fid']] < $check_last_post))
				{
					$new_posts_count++;
				}
			}
		}
	}
	
	return $new_posts_count;
}


function pan_notify_get_active_topics()
{
	global $forum_db;

	$query = array(
		'SELECT'	=> 'COUNT(t.id)',
		'FROM'		=> 'topics AS t',
		'WHERE'		=> 't.last_post>'.(time() - 86400).' AND t.moved_to IS NULL',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$recent_count = $forum_db->result($result);
	
	return $recent_count;
}

function pan_notify_get_unanswered_topics()
{
	global $forum_db;

	$query = array(
		'SELECT'	=> 'COUNT(t.id)',
		'FROM'		=> 'topics AS t',
		'WHERE'		=> 't.num_replies=0 AND t.moved_to IS NULL',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$unanswered = $forum_db->result($result);
	
	return $unanswered;
}

function pan_notify_get_pun_pm_new_msg()
{
	global $forum_db, $forum_user;

	if ($forum_db->table_exists('pun_pm_messages'))
	{
		$query = array(
			'SELECT'	=> 'COUNT(pm.id)',
			'FROM'		=> 'pun_pm_messages AS pm',
//			'WHERE'		=> 'pm.read_at=0 AND pm.receiver_id='.$forum_user['id']
			'WHERE'      => 'pm.read_at=0 AND pm.deleted_by_receiver=0 AND pm.receiver_id='.$forum_user['id']
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$pm_msgs = $forum_db->result($result);

		return $pm_msgs;
	}
}

function pan_notify_get_pan_consultor_posts()
{
	global $forum_db;
	
	if ($forum_db->table_exists('pan_consultor_posts'))
	{
		$query = array(
			'SELECT'	=> 'COUNT(p.id)',
			'FROM'		=> 'pan_consultor_posts AS p',
			'WHERE'		=> 'p.status=\'sent\'',
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$output = $forum_db->result($result);
		
		return $output;
	}
}
